// get_consoleA.cpp
// This file is public domain software (PDS).
#include <windows.h>
#include <vector>
#include <string>
#include <cstdio>
#include <cassert>
using namespace std;

int main(void)
{
    HANDLE hCon = GetStdHandle(STD_OUTPUT_HANDLE);
    assert(hCon);

    CONSOLE_SCREEN_BUFFER_INFO BufInfo;
    BOOL b = GetConsoleScreenBufferInfo(hCon, &BufInfo);
    assert(b);

    int Count = BufInfo.dwSize.X * BufInfo.dwCursorPosition.Y;
    std::vector<CHAR_INFO> vecCharInfo(Count);

    COORD BufSize;
    BufSize.X = BufInfo.dwSize.X;
    BufSize.Y = BufInfo.dwCursorPosition.Y;

    for (int Y = 0; Y < BufInfo.dwCursorPosition.Y; ++Y)
    {
        COORD Coord = {0, Y};
        SMALL_RECT rect = {0, Y, BufInfo.dwSize.X - 1, Y + 1};
        b = ReadConsoleOutputA(hCon, &vecCharInfo[0], BufSize, Coord, &rect);
        assert(b);
    }

    FILE *fp = fopen("logA.txt", "wb");
    assert(fp);

    for (int Y = 0; Y < BufInfo.dwCursorPosition.Y; Y++)
    {
        CHAR_INFO *Line = &vecCharInfo[Y * BufInfo.dwSize.X];

        int ColumnMax = BufInfo.dwSize.X - 1;
        for (; ColumnMax >= 0; --ColumnMax)
        {
            if (Line[ColumnMax].Char.AsciiChar != 0)
                break;
        }

        for (int X = 0; X <= ColumnMax; ++X)
        {
            fwrite(&Line[X].Char.AsciiChar, 1, sizeof(char), fp);
        }

        fwrite("\r\n", 2, sizeof(char), fp);
    }

    fclose(fp);

    return 0;
}
