// get_consoleW.cpp
// This file is public domain software (PDS).
#include <windows.h>
#include <vector>
#include <string>
#include <cstdio>
#include <cassert>
using namespace std;

// Retrives the character width of a wide character
extern "C" int mk_wcwidth(wchar_t ucs);

int main(void)
{
    HANDLE hCon = GetStdHandle(STD_OUTPUT_HANDLE);
    assert(hCon);

    CONSOLE_SCREEN_BUFFER_INFO BufInfo;
    BOOL b = GetConsoleScreenBufferInfo(hCon, &BufInfo);
    assert(b);

    int Count = BufInfo.dwSize.X * BufInfo.dwCursorPosition.Y;
    std::vector<CHAR_INFO> vecCharInfo(Count);

    COORD BufSize;
    BufSize.X = BufInfo.dwSize.X;
    BufSize.Y = BufInfo.dwCursorPosition.Y;

    for (int Y = 0; Y < BufInfo.dwCursorPosition.Y; ++Y)
    {
        COORD Coord = {0, Y};
        SMALL_RECT rect = {0, Y, BufInfo.dwSize.X - 1, Y + 1};
        b = ReadConsoleOutputW(hCon, &vecCharInfo[0], BufSize, Coord, &rect);
        assert(b);
    }

    FILE *fp = fopen("logW.txt", "wb");
    assert(fp);

    for (int Y = 0; Y < BufInfo.dwCursorPosition.Y; Y++)
    {
        CHAR_INFO *Line = &vecCharInfo[Y * BufInfo.dwSize.X];

        int ColumnMax = BufInfo.dwSize.X - 1;
        for (; ColumnMax >= 0; --ColumnMax)
        {
            if (Line[ColumnMax].Char.UnicodeChar != 0)
                break;
        }

        for (int X = 0; X <= ColumnMax; )
        {
            fwrite(&Line[X].Char.UnicodeChar, 1, sizeof(WCHAR), fp);
            int width = mk_wcwidth(Line[X].Char.UnicodeChar);
            if (width > 0)
                X += width;
            else
                ++X;
        }

        fwrite(L"\r", 1, sizeof(WCHAR), fp);
        fwrite(L"\n", 1, sizeof(WCHAR), fp);
    }

    fclose(fp);

    return 0;
}
